import { world, BlockPermutation } from "@minecraft/server";

export class BlockUtil {
    static getBlock(dim, loc) {
        return world.getDimension(dim).getBlock(loc);
    }

    static setBlock(dim, loc, blockId, states = {}) {
        const blockPerm = BlockPermutation.resolve(blockId, states);
        this.getBlock(dim, loc).setPermutation(blockPerm);
    }

    static setState(block, stateName, stateValue) {
        block.setPermutation(block.permutation.withState(stateName, stateValue));
    }

    static setStates(block, states = {}) {
        for (let stateName in states) {
            this.setState(block, stateName, states[stateName]);
        };
    }
}