import { Direction, Vector } from "@minecraft/server";
import { axis } from "../enum/system";

export function capitalize(str) {
    return str.replace(/( |^)[a-z]/g, (L) => L.toUpperCase());
}

export function lowerCaseFirst(str) {
    return str.replace(/( |^)[A-Z]/g, (U) => U.toLowerCase());
}

export class Util {    
    static axis(dir) {
        const value = capitalize(dir);
        if (value == Direction.East || value == Direction.West) {
            return axis.X;
        } else if (value == Direction.Down || value == Direction.Up) {
            return axis.Y;
        } else if (value == Direction.North || value == Direction.South) {
            return axis.Z;
        };
    }

    static aimLoc({x, y, z}, dir) {
        const value = capitalize(dir);
        let aimLoc = {};
        aimLoc.x = x + (value == Direction.West ? -1 : (value == Direction.East ? 1 : 0));
        aimLoc.y = y + (value == Direction.Down ? -1 : (value == Direction.Up ? 1 : 0));
        aimLoc.z = z + (value == Direction.North ? -1 : (value == Direction.South ? 1 : 0));
        return aimLoc;
    }

    static singleFaceLocation(dir, faceLoc) {
        const surface = { ...faceLoc };
        delete surface[this.axis(dir)];
        const loc = {
            x: Object.values(surface)[0],
            y: Object.values(surface)[1]
        };
        return loc;
    }

    static transToWorldLoc(vec3) {
        let integerNum = 0;
        for(let axis in vec3) {
            if(Number.isInteger(vec3[axis])) {
                integerNum++;
                continue;
            } else {
                break;
            };
        };
        if(integerNum == 3) {
            return Vector.add(vec3, {x: 0.5, y: 0.5, z: 0.5});
        } else return vec3;
    }
}