import { world, GameMode } from "@minecraft/server";
import { EntityUtil } from "../../library/utilities/entityUtil";

export class PlayerData {
    constructor(player) {
        this.name = player.name;
        this.rotation = player.getRotation().y;
        this.mainhandSlot = player.getComponent("inventory").container.getSlot(player.selectedSlot);
        const target = Array.from(world.getPlayers({
            name: this.name,
            gameMode: GameMode.creative
        }));
        this.isCreativeMode = target.length > 0 ? true : false;
    }

    getAxis() {
        return EntityUtil.entityAxis(this.rotation);
    }

    setMainhandItem(itemStack, ignoreGameMode = false) {
        if (ignoreGameMode || !ignoreGameMode && !this.isCreativeMode) {
            this.mainhandSlot.setItem(itemStack);
        };
    }

    decrementStack(ignoreGameMode = false) {
        if (ignoreGameMode || !ignoreGameMode && !this.isCreativeMode) {
            this.mainhandSlot.amount <= 1 ? this.mainhandSlot.setItem() /* 0 -> undefined */ : this.mainhandSlot.amount--;
        };
    }
}